/******************************************************************
 * Copyright (c) 1990  MOTOROLA, Inc.                             *
 * NOTICE: The information contained in this file is proprietary  *
 * to MOTOROLA, INC. and is being made available  to MOTOROLA'S   *
 * customers under strict license agreements.              *
 * Use or disclosure of this information is permissible only      *
 * under the terms of the existing license agreement.      *
 ******************************************************************/

#include <stdio.h>
#include <ctype.h>
#include	"system.h"			/* variable type defines */
#include	"imp.h"
#include	"hdlc.h"
#include	"la.h"

int dest = -1;		/* xmit packet: destination address */
int pkttype = -1;		/* xmit packet: packet type */
octet xbuf[512] = "";		/* xmit packet: packet data contents */
int delay;		/* xmit packet: delay between repeats */
int doit;		/* xmit packet: number of repeats */
octet dataParam[maxFrameSize];	/* receive packet: data portion of frame */


/***************************************************************************/
/*  Procedure: la_sinit	
	application layer
	called one time at program startup to initialize global variables
*/
/***************************************************************************/
la_sinit()
{
	dest = -1;		/* xmit packet: destination address */
	pkttype = -1;		/* xmit packet: packet type */
	xbuf[0] = '\0';		/* xmit packet: packet data contents */
	delay = 1;		/* xmit packet: delay between repeats */
	doit = 0;		/* xmit packet: number of repeats */
}

/***************************************************************************/
/*  Procedure: la_init				( USER INTERFACE ROUTINE )
	Called to initialize 302 hardware and la driver for localtalk usage 
*/
/***************************************************************************/
la_init(argc,argv)
int argc;
char *argv[];
{
	octet hint;
	Boolean server;
	int result;
	int c;
	extern int optind;
	extern char *optarg;

	hint=0;
	server=0;
	while((c=getopt(argc,argv,"sh:SH:")) != EOF)
		switch(c) {
		case 's':		/* select server */
		case 'S':
			server = 1;
			break;
		case 'h':		/* seed for network address */
		case 'H':
			hint = aton(optarg);
			break;
		case '?':
			help(0,(char **)0,"init");
			return(0);
		}
	if(argc==1) {		/* prompt user if no command line options */
		printf("Is this node a server node [n]: ");
		if(getyesno())
			server = 1;
		printf("Do you wish to seed the starting address [n]: ");
		hint = 0;
		if(getyesno()) {
			printf("Enter address seed [none]: ");
			hint = readnum();
		}
	}

	if( (result=InitializeLLAP(hint,server)) != OKinitialize)
		printf("Error: Cannot initialize driver: code = %d/%s",result,lapresult[result]);
	  else
		printf("Net Address is x%x\n",MyAddress);
	return(0);
}

/***************************************************************************/
/*  Procedure: la_transmit			( USER INTERFACE ROUTINE )
	Called to transmit a localtalk packet
*/
/***************************************************************************/
la_transmit(argc,argv)
int argc;
char *argv[];
{
	int result,repeat;
	void *pp;
	int c;
	extern int optind;
	extern char *optarg;
	int i,badflag;
	extern char *strcpy();

	repeat = 0;
	while((c=getopt(argc,argv,"rd:t:p:")) != EOF)
		switch(c) {
		case 'r':		/* repeat last packet */
		case 'R':
			repeat = 1;
			break;
		case 'd':
		case 'D':
			dest = aton(optarg);
			break;
		case 't':
		case 'T':
			pkttype = aton(optarg);
			break;
		case 'p':
		case 'P':
			strcpy(xbuf,optarg);
			break;
		case '?':
			help(0,(char **)0,"xmit");
			return;
		}
	if(fAdrValid==0) {
		printf("Driver has not been initialized\n");
		return;
	}
	badflag=0;
	if(dest<=0 || dest>=256) badflag=1;
	if(pkttype<1 || pkttype>=0x80) badflag=1;
	if(xbuf[0] == '\0') badflag=1;

	/* prompt user if necessary */
	if(repeat==0 || badflag) {
		for(dest= -1;dest<=0 || dest>=256;) {
			printf("Enter Dest. Address [0]: ");
			dest = readnum();
		}
		for(pkttype= -1;pkttype<1 || pkttype>=0x80;) {
			printf("Enter packet type [0]: ");
			pkttype = readnum();
		}
		printf("Enter String to Transmit  <cr> to end: ");
		gets(xbuf);
		xbuf[strlen(xbuf)-1]='\0';
		printf("Enter number of times to Transmit [0]: ");
		doit = readnum();
		if(doit == 0)
			return;
		if(doit>1) {
			printf("Enter delay between packets (mS) [0]: ");
			delay = readnum();
		} else
			delay = 0;
	}

	pp = (void *)xbuf;

	/* do the transmit */
	for(repeat=doit;repeat;repeat--) {
		for(i=delay;i;i--)
			for(STimer(1000);!GTimer();); /* 1mS delay */
		if( (result=TransmitPacket((anAddress)dest,(aLAPtype)pkttype,
		   (aDataField *)pp,strlen(xbuf))) != transmitOK) {
			printf("\n error, result=x%x/%s\n",result,&(lapresult[result][0]));
		}
	}
}

/***************************************************************************/
/*  Procedure: la_receive			( USER INTERFACE ROUTINE )
	Called to display all receive data packets 
*/
/***************************************************************************/
la_receive(argc,argv)
int argc;
char *argv[];
{
	anAddress dstParam;
	anAddress srcParam;
	aLAPtype typeParam;
	int dataLength;
	int i,j,c,index;
	int silent;
	int result;
	int c1;
	extern int optind;
	extern char *optarg;

	silent = 0;
	while((c1=getopt(argc,argv,"aA")) != EOF)
		switch(c1) {
		case 'a':		/* repeat last packet */
		case 'A':
			silent = 1;
			break;
		case '?':
			help(0,(char **)0,"receive");
			return(0);
		}

	if(fAdrValid==0) {
		printf("Driver has not been initialized\n");
		return;
	}
	if(RPacketAvail() == 0) {
		printf("no outstanding receive packets\n");
		return;
	}

	j= la_rline(0);			/* clear line counter */
					/* j= is to satisfy lint */
	j=1;	
	while(RPacketAvail() != 0) {		/* for each packet */
		if( (result=ReceivePacket(&dstParam,&srcParam,&typeParam,
				dataParam,&dataLength)) != receiveOK) {
			printf("Error: receive packet: code=%d/%s\n",result,lapresult[result]);
			return;
		}

		if(silent!=0)
			continue;

		if(la_rline(1)!=0)
			break;
		printf("\n%02d: ",j++);
		printf("D[%d/x%x] S[%d/x%x] T[%d/x%x] Length[%d]\n",
			dstParam,dstParam,
			srcParam,srcParam,
			typeParam,typeParam,
			dataLength);
		if(la_rline(1)!=0)
			break;

		for(index=0;index<dataLength;index+=16) {
			for(i=index;1;i++) {
				if(i < dataLength)
					printf(" %02x",dataParam[i]);
				  else
					printf("   ");
				if( (i%16)==15)
					break;
			}
			printf("    ");
			for(i=index;1;i++) {
				c = dataParam[i];
				if(i < dataLength)
					if(isprint(c))
						putchar(c);
					  else
						putchar('.');
				if( (i%16)==15)
					break;
			}
			putchar('\n');
			if(la_rline(1)!=0)
				return;
		}
	}
}

/* check for full screen, prompt user, potentially return kill flag */
la_rline(parm)
int parm;
{
	static linecount = 0;
	int response;

	if(parm==0) {
		linecount=0;
		return(0);
	}
	if(++linecount >=21) {
		linecount=0;
		printf("\n Enter CR to continue ('.' to quit)");
		while( (response=getchar()) != '\n')
			if(response=='.' || response=='q' || response=='Q') {
				while( (response=getchar()) != '\n') ;
				return(1);
			}
	}
	return(0);
}

/***************************************************************************/
/*  Procedure: la_raudit				( USER INTERFACE ROUTINE )
	Called to audit the receive buffer structure
	procedure indicates which list (free, data, or user(??)) contains
		the buffer structure
*/
/***************************************************************************/
la_raudit(argc,argv)
int argc;
char *argv[];
{
	struct rbuf *p,*lp;
	Boolean used[MAXRBUF];
	int i,index;
	UCHAR *cp;
	extern IMP_BD *rbd_p;
	extern struct rbuf rbuffer[];
	extern struct rbuf freelist;
	extern struct rbuf rhdr;
	extern struct rbuf rtail;

	if(argc != 1) {
		help(0,(char **)0,"raudit");
		return;
	}
	for(i=0;i<MAXRBUF;i++)
		used[i] = FALSE;

	printf("free:");
	for(p= freelist.next; p != (struct rbuf *)0; p=p->next) {
		/* check address range */
		if(p<rbuffer || p>= &(rbuffer[MAXRBUF])) {
			printf("address range error: x%lx",p);
			break;
		}
		used[index = p-rbuffer]=TRUE;
		printf(" %d",index);
	}
	putchar('\n');

	lp = (struct rbuf *)0;
	printf("recv:");
	for(p= rhdr.next; p != (struct rbuf *)0; p=p->next) {
		/* check address range */
		if(p<rbuffer || p>= &(rbuffer[MAXRBUF])) {
			printf("address range error: x%lx",p);
			break;
		}
		used[index = p-rbuffer]=TRUE;
		printf(" %d",index);
		lp = p;
	}
	putchar('\n');
	if( ((lp==(struct rbuf *)0)&&(rtail.next==(struct rbuf *)0)) ||
	    ((lp!=(struct rbuf *)0)&&(lp==rtail.next))  )
		printf("tail pointer is correct\n");
	  else	{
		printf("tail pointer is in error\n");
		printf("   lastp=x%lx  tailp=x%lx\n",lp,rtail.next);
	}

	/* check rd[0] */
	cp = rbd_p->buf;
	if(cp != (UCHAR *)0) {
		/* check address range */
		p = (struct rbuf *)(cp-sizeof(struct rbuf *)-sizeof(UINT16));
		if(p<rbuffer || p>= &(rbuffer[MAXRBUF])) {
			printf("rdb: address range error: x%lx\n",p);
		} else {
			used[index = p-rbuffer]=TRUE;
			printf("rcv buf: %d\n",index);
		}
	} else
		printf("receive buffer descriptor is in error\n");

	/* check allocation */
	printf("user/unknown buffers:");
	for(i=0;i<MAXRBUF;i++)
		if(used[i]==FALSE)
			printf(" %d",i);
	putchar('\n');

}

/***************************************************************************/
/*  Procedure: la_stat				USER INTERFACE ROUTINE
	lists (and possibly clears) node oriented network statistics
*/
/***************************************************************************/
la_stat(argc,argv)
int argc;
char *argv[];
{
	int forceclear;
	int c;
	extern int optind;
	extern char *optarg;

	forceclear=0;
	while((c=getopt(argc,argv,"cC")) != EOF)
		switch(c) {
		case 'c':		/* clear all counter, no print */
		case 'C':
			forceclear = 1;
			break;
		case '?':
			help(0,(char **)0,"stat");
			return(0);
		}

	if(forceclear==0) {
		printf("Protocol Information:\n");
		printf("\t                  local node address = x%x\n",hdlcp->r_addr1);
		printf("\t                           fAdrInUse = %d\n",fAdrInUse);
		printf("\t                           fAdrValid = %d\n",fAdrValid);

#ifdef	STATISTIC
		printf("\nProtocol Specific Counters:\n");
		printf("\t       # of                 deferals = %d\n",deferCount);
		printf("\t       # of               collisions = %d\n",collsnCount);
		printf("\t       # of           receive frames = %ld\n",RFrameCount);
		printf("\t       # of     receive data packets = %ld\n",RDataCount);
		printf("\t       # of receive buffer overflows = %ld\n",ROvrFlow);
#endif
		printf("\nMC68302 Specific Counters:\n");
		printf("\t               Discard Frame Counter = %d\n",hdlcp->discard_cnt);
		printf("\t                   CRC Error Counter = %d\n",hdlcp->crc_cnt);
		printf("\t              Abort Sequence Counter = %d\n",hdlcp->abort_cnt);
		printf("\tNonmatching Address Received Counter = %d\n",hdlcp->nmf_cnt);
		printf("\t        Frame Retransmission Counter = %d\n",hdlcp->retx_cnt);

		printf("\nDo you wish to clear these counters [n]?  ");
		if(!getyesno())
			return;
	}
	
#ifdef	STATISTIC
	deferCount=collsnCount=0;
	RFrameCount=RDataCount=0L;	/* receive frame statisics */
	ROvrFlow=0L;
#endif
	hdlcp->discard_cnt = 0;
	hdlcp->crc_cnt = 0;
	hdlcp->abort_cnt = 0;
	hdlcp->nmf_cnt = 0;
	hdlcp->retx_cnt = 0;
	printf("The counters have been cleared\n");
}

/***************************************************************************/
/*  Procedure: bkgrd
	procedure is called automatically by __getc when characters are
	not currently available.

	can be invoked directly from command line if desired
		(this shouldn't ever be necessary and doesn't show in
		help file)
*/
/***************************************************************************/
bkgrd()
{
	static int time=0;

	time++;
	/* declare routines to execute and their rep rates */
	if(init_complete == TRUE)
		la_echobkgrd();		/* check for echo packets */
}


