/******************************************************************
 * Copyright (c) 1990  MOTOROLA, Inc.                             *
 * NOTICE: The information contained in this file is proprietary  *
 * to MOTOROLA, INC. and is being made available  to MOTOROLA'S   *
 * customers under strict license agreements.              *
 * Use or disclosure of this information is permissible only      *
 * under the terms of the existing license agreement.      *
 ******************************************************************/

#define	_MAIN_
#include "stdio.h"
#include "cmds.h"
#include "help.h"

#define	PASSTHROUGH	/* allow unknown commands to pass through to
					underlayer (ROM) debugger */

char dlver[] = "LOCALTALK ADAPTER DEBUGGER PROGRAM V1.0";
char PROMPT[] = "LAbug";		/* prompt */
char exitstr[] = "quitting localtalk debugger";
char SUBNAME[] = "302bug";		/* name of subsystem to trap to */

#define MAXLINE 80
#define	MAXARG	30
#define	BS	'\010'		/* erase last character = ^H */
#define	EL	'\025'		/* erase line buffer = ^U */
char cmdline[MAXLINE+1];
char line_argv[MAXLINE+1];
static int argc;
static char *argv[MAXARG];

#define	MAXLEVEL	5
int debug=0;
int sdebug=0;

extern char *strcpy();

main()
{
	/* display who we are */
	printf("%s (%s)\n",dlver,__DATE__);
	printf("\tCopyright (c) 1990, Motorola Inc.\n");

	/* place any inits here */
	INITS;		/* from cmds.h file */
	debug=sdebug=0;

	/* process next command */
	while(1) {
		printf("%s> ",PROMPT);		/* displ prompt */
		getcmd();
		if(!argc)		/* if no arguments */
			continue;
		if(userprgm(argc,argv))  /* if user program, execute it */
			continue;

		/* unknown command, assume it is a monitor command*/
#ifndef	PASSTHROUGH
		printf("Unknown %s Command\n",PROMPT);
#endif
#ifdef	PASSTHROUGH
		if(!strcmp(cmdline,"302sw")) { /* dont allow 302sw */
			printf("302sw accessible only from 302bug\n");
			continue;
		}
		execmon(cmdline);
#endif
	}
}

quitla()
{
	printf("\n%s\n",exitstr);
	exit(0);	/* end of emulation */
}

userprgm(argc,argv)
int argc;
char *argv[];
{
	register int i;

	extern int optind,opterr;
	opterr = 1;
	optind = 0;		/* reset getopt for users */

	for(i=0;cmd[i].fcn!=0;i++) {
		if(strcmp(cmd[i].name,argv[0])==0)  {
			/* found match call routine */
			(*(cmd[i].fcn))(argc,argv);
			return(1);
		}
	}
	return(0);
}

test(argc,argv)
int argc;
char *argv[];
{
	register int narg;

	printf("argc=%d\n",argc);
	for(narg=0;narg<argc;narg++)
		printf("test: arg %d %s\n",narg,argv[narg]);
}

help(argc,argv,pgrep)
int argc;
char *argv[];
char *pgrep;
{
	char **p, *ps;		/* search string */

	/* process errors */
	if(argc == 1) {	/* called from cmdproc - print all */
		printf("%s help:\n",PROMPT);
		for(p=errtab;**p;p++)
			printf("%s\n",*p);
#ifdef	PASSTHROUGH
		{
		int response;

		printf("\n Enter CR to continue ('.' to quit)");
		while( (response=getchar()) != '\n')
			if(response=='.' || response=='q' || response=='Q') {
				while( (response=getchar()) != '\n');
				return;
			}
		printf("%s help:\n\n",SUBNAME);
		strcpy(cmdline,"help");
		execmon(cmdline);

		}
#endif
		return;
	} else
	ps = (argc==2) ? *++argv : pgrep;

	printf("%s help (grep):\n",PROMPT);
	/* perform grep on errtab */
	for(p=errtab;**p;p++)
		if(strncmp(*p,ps,strlen(ps))==0)
			printf("%s\n",*p);
}

rundebug(argc,argv)
int argc;
char **argv;
{
	int *p;

	p= &debug;
	if(!strcmp(*argv,"sdebug"))
		p = &sdebug;
	if(argc>1) {
		if( (*p = aton(*++argv))>=MAXLEVEL)
			*p = MAXLEVEL;
	} else
		if(++*p > MAXLEVEL)
			*p=0;
	if(p == &sdebug)
		putchar('s');
	printf("debug is now set at level: %d\n",*p);
}

getcmd()
{
	register int c;
	char *p;
	extern char *strtok();

	for(p=cmdline;(c=getchar()) != '\n'; ) {
		switch(c) {
		case BS:
			if(p>cmdline)
				p--;	/* backup */
			putchar(' ');
			putchar(BS);
			break;
		case EL:
			p = cmdline;
			putchar('\n');
			break;
		default:
			if(p< &(cmdline[MAXLINE]) )
				*p++ = c;
			break;
		}
	}
	*p = '\0';
	strcpy(line_argv,cmdline);
	/* generate argc,argv from command line */
	argc=0;
	for(p=line_argv;(argv[argc++]=strtok(p,"	 "))!=NULL;p=(char *)0);
	return(--argc);
}

/* trap it to 302/340bug */
execmon(p)
char *p;
{
	trap15(1,p);
	trap15(1,"end 302bug trap");	/* kludge way to get rest of output */
}


