/******************************************************************
 * Copyright (c) 1990  MOTOROLA, Inc.                             *
 * NOTICE: The information contained in this file is proprietary  *
 * to MOTOROLA, INC. and is being made available  to MOTOROLA'S   *
 * customers under strict license agreements.              *
 * Use or disclosure of this information is permissible only      *
 * under the terms of the existing license agreement.      *
 ******************************************************************/

#include "system.h"

/*#define	OCTAL*/			/* define if octal numbers allowed*/

/***************************************************************************/
/*  Procedure: ones(byte)
	return the number of set bits (one) in the byte
*/
/***************************************************************************/
ones(byte)
UCHAR byte;
{
	int i,sum;

	sum = 0;
	for(i=1; i<0x100 ;i<<=1)
		sum += byte & i;
	return(sum);
}


/***************************************************************************/
/*  Procedure: aton(string)
	convert a string into an unsigned integer.
	the following formats are supported:
		[1-9][0-9]*	decimal
		0[0-7]*		octal
		0x[0-9a-f]*	hex
		x[0-9a-f]*	hex
*/
/***************************************************************************/
aton(p)
char *p;
{
	int base;
	register int digit;
	register int num;

	base = 10;
	num = 0;

	for(; (digit= *p);p++) {
		digit = tolower(digit);
		/* first determine base */
#ifdef	OCTAL
		if(num==0 && digit=='0' && base==10) { /* leading 0 */
			base = 8;
			continue;
		}
#endif
		if(num==0 &&(digit=='x' || digit=='$')){/*leading x, $, or 0x*/
			base = 16;
			continue;
		}
		if(digit>='a' && digit<='f')
			digit += 10 - 'a';
		  else if(isdigit(digit))
			digit -= '0';
		  else
			break;		/* illegal syntax, terminate process */
		/* digit is now an integer 0-15 */
		if(digit>=base)		/* illegal digit */
			break;
		num = num*base + digit;
	}
	return(num);
}

/***************************************************************************/
/*  Procedure: readnum()
	read a line from the command terminal
	convert via aton and return value
*/
/***************************************************************************/
readnum()
{
	char	linebuf[512];
	extern char *gets();

	gets(linebuf);
	return(aton(linebuf));
}

/***************************************************************************/
/*  Procedure: getyesno()
	read a line from the terminal
	if any character in line is a "y", then return true
		else return false
*/
/***************************************************************************/
getyesno()
{
	char linebuf[512];
	extern char *strchr(),*gets();

	gets(linebuf);
	if(strchr(linebuf,'y')!=(char *)0   ||  strchr(linebuf,'Y')!=(char *)0)
		return(TRUE);
	return(FALSE);
}


